/*   Copyright 2004 Salesforce.com
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

/*
 * Copyright (c) 2000-2002  BEA Systems, Inc.   All Rights Reserved
 *
 * File:    PortalVisitorConstants.java
 */

package com.bea.jsptools.portal;

/**
 *  Constants for Portal Visitor Tools
 *
 *
 */

public class PortalVisitorConstants
{
    public static final String TARGET_PAGE_ID          = "_targetPage";
    public static final String MAIN_BOOK        = "MainBook";
    public static final String VISITOR_TOOLS_MAIN_PAGE = "VisitorToolsMainPage";
    public static final String VISITOR_TOOLS_EDIT_PAGE = "VisitorToolsEditPage";
    public static final String VISITOR_TOOLS_EDIT_BOOK = "VisitorToolsEditBook";

    public static final String WEB_APP_NAME = "webAppName";
    public static final String PORTAL_PATH  = "portalPath";
    public static final String DESKTOP_PATH = "desktopPath";

    public static final String PORTLET  = "portlet";
    public static final String BOOK     = "book";
    public static final String PAGE     = "page";
    public static final String NEW_BOOK = "newbook";
    public static final String NEW_PAGE = "newpage";

    public static final String LOOK_AND_FEEL_ID = "lookAndFeelId";
    public static final String THEME_ID         = "themeId";
    public static final String LAYOUT_ID        = "layoutId";
    public static final String MENU_ID          = "menuId";

    public static final String RESOURCE_ID        = "resourceId";
    public static final String RESOURCE_TYPE      = "resourceType";
    public static final String RENAME_RESOURCE    = "renameResource";
    public static final String SHOW_PAGE_CONTENTS = "showPageContentsVal";

    public static final String BOOK_TO_MOVE_RESOURCE_TO   = "bookToMoveTo";
    public static final String PAGE_TO_MOVE_RESOURCE_TO   = "pageToMoveTo";
    public static final String RESOURCE_TO_MOVE           = "resourceToMove";
    public static final String RESOURCE_TYPE_TO_MOVE      = "resourceTypeToMove";
    public static final String RESOURCE_TO_MOVE_FROM      = "resourceToMoveFrom";
    public static final String RESOURCE_TYPE_TO_MOVE_FROM = "resourceTypeToMoveFrom";

    public static final String EDIT_BOOK = "editBook";
    public static final String EDIT_BOOK_NAME = "editBookName";
    public static final String EDIT_PAGE = "editPage";
    public static final String EDIT_PAGE_NAME = "editPageName";

    public static final String SAVE_PLACEHOLDERS = "savePlaceholders";
    public static final String MOVE_PLACEABLE_IDS = "movePlaceableIds";
    public static final String MOVE_PLACEABLE_PLACEHOLDERS = "movePlaceablePlaceholders";
    public static final String MOVE_PLACEABLE_POSITIONS = "movePlaceablePositions";
    public static final String DELETE_PLACEABLE_IDS = "deletePlaceableIds";
    public static final String ADD_PLACEABLE_IDS = "addPlaceableIds";
    public static final String ADD_PLACEABLE_PLACEHOLDERS = "addPlaceablePlaceholders";
    public static final String ADD_PLACEABLE_POSITIONS = "addPlaceablePositions";

    public static final String SAVE_BOOK = "saveBook";
    public static final String MOVE_NAVIGABLE_IDS = "moveNavigableIds";
    public static final String MOVE_NAVIGABLE_POSITIONS = "moveNavigablePositions";
    public static final String DELETE_NAVIGABLE_IDS = "deletePlaceableIds";
    public static final String ADD_NAVIGABLE_IDS = "addPlaceableIds";
    public static final String ADD_NAVIGABLE_POSITIONS = "addPlaceablePositions";
}
